/*
*This functions purpose is to build a custom network based on the users input.
*The user will start by choosing a node from a selection list and adding 
*it to the network scene. 
*
*Next, the user has the options of browsing all the information of the added node,
*or adding a second or third or nth node from the same selection list.
*
*Any node in the scene can be clicked on to view information. Within the
*generated information, the user will have the option of expanding the node to
*show all connections to other nodes, deleting the node or closing the nodes
*expansions. Additional options will be developed.
*
*The east pane of the interface will contain the node information related to the
*highlited node in the network scene. 
*
*A list of connecting nodes will allow the user to highlight nodes in the scene.
*
*
*/

var customBuild = function customBuild(){
	
	
	
}

function buildNetwork(){
	
	var moveForward = false,
		 moveBackwards = false,
		 moveLeft = false,
	  	 moveRight = false,
		 moveUp = false,
		 moveDown = false,
		 plane, objects = [],
		 PI2 = Math.PI * 2,
		 targetMoveLeft = false,
		 targetMoveRight = false;
		 
	var	 camera, 
		 scene = new THREE.Scene(),
		 INTERSECTED,
		 objects = [],
		 stats,
		 renderer,
		 canvasHeight,
		 canvasWidth,
		 particle,
		 particle2,
		 mouse = { x: 0, y: 0 },
		 line;
	var projector = new THREE.Projector();	 
		 initBuild();
		 animate();
	
	function initBuild(){
			
			//check if a network already exists, need to fix this
      		if(document.getElementById('build')){
					
			}
			
			//create the particle materials, color as a param later
			var materialA = getMaterialA();	
			var materialB = getMaterialB();
			
			//create the THREE.js objects for initializing the network						
			var geometry = new THREE.Geometry();
			var group = new THREE.Object3D();
      		var projector = new THREE.Projector();
      		
      		
      		//obtain the center pane dimensions before any further work
			canvasWidth = 400;//$("#build").width();
			canvasHeight = 400;//$("#build").height();
      		
      		//camera properties for the PerspectiveCamera
      		var fov = 		100,
      			 aspect = 	1,
      			 near = 		0.1,
      			 far = 		3500;
			
			//this will count the number of edges when creating particles      			 
      		var edgeCount = 0;
      		
			//check the parameters again. Something is off.
			//THREE.PerspectiveCamera = function ( fov, aspect, near, far ) 
			camera = new THREE.CombinedCamera( canvasWidth, canvasHeight, fov, near, far, near, far);
			camera.target = new THREE.Vector3( 100, 100, 100 );

 			//create a THREE.js scene: camera, group
         //	scene = new THREE.Scene();
		
			scene.add( camera );
			scene.add(group);
      		//scene.add(projector);
			//create a THREE.js renderer object
			renderer = new THREE.WebGLRenderer({clearColor: 0x000000, clearAlpha: 1 });
			renderer.setSize(canvasWidth, canvasHeight);
				
			//append the new renderer (a canvas element) to the HTML object
			$('#build').append( renderer.domElement );
				
			
				particle = new THREE.Particle( materialA );
				particle.position.x = 100;
				particle.position.y = 100;
				particle.position.z = 100;
				particle.position.normalize();
				particle.scale.x = particle.scale.y = 5;
				particle.name = "Particle";	
				objects.push(particle);	
				console.log(particle.name);
				group.add(particle);			
			
			//scene.add(group);		
			
			 
			//document.addEventListener( 'mousedown', onDocumentMouseDown, false ); 
		
		
	}//end initBuild
	
	
	var radius = 100;
	var theta = 0;

	function render() {

				theta += 0.2;

				camera.position.x = radius * Math.sin( theta * Math.PI / 360 );
				camera.position.y = radius * Math.sin( theta * Math.PI / 360 );
				camera.position.z = radius * Math.cos( theta * Math.PI / 360 );

				camera.lookAt( scene.position );

				// find intersections

				var vector = new THREE.Vector3( mouse.x, mouse.y, 1 );
				projector.unprojectVector( vector, camera );

				var ray = new THREE.Ray( camera.position, vector.subSelf( camera.position ).normalize() );

				var intersects = ray.intersectObjects( objects );

				if ( intersects.length > 0 ) {

					if ( INTERSECTED != intersects[ 0 ].object ) {

						if ( INTERSECTED ) INTERSECTED.material.color.setHex( INTERSECTED.currentHex );

						INTERSECTED = intersects[ 0 ].object;
						INTERSECTED.currentHex = INTERSECTED.material.color.getHex();
						INTERSECTED.material.color.setHex( 0xff0000 );

					}

				} else {

					if ( INTERSECTED ) INTERSECTED.material.color.setHex( INTERSECTED.currentHex );

					INTERSECTED = null;

				}

				renderer.render( scene, camera );

			}
	
	
	function animate(){
		requestAnimationFrame( animate );
		render();
		//stats.update;
	}//end animate
	
}//end createBuild